module Kanoah
  class Client
    include HTTParty

    include Kanoah::Services::Authentication
    include Kanoah::Services::IssueLink
    include Kanoah::Services::TestCase
    include Kanoah::Services::TestPlan
    include Kanoah::Services::TestResult
    include Kanoah::Services::TestRun

    include Kanoah::Helper::TestCase

    default_options.update(verify: false)
    format :json
    attr_reader :test_run_id, :project, :response


    def initialize(options={})
      self.class.base_uri options.fetch(:base_url)     { Kanoah.config.base_url }
      @environment = options.fetch(:environment)       { Kanoah.config.environment }
      @test_run_id = options.fetch(:test_run_id)       { Kanoah.config.test_run_id }
      @project_id  = options.fetch(:project_id)        { Kanoah.config.project_id }
      username     = options.fetch(:username)          { Kanoah.config.username }
      password     = options.fetch(:password)          { Kanoah.config.password }
      token = Base64.encode64(username+':'+password)
      set_access_token(token[0..-2])
    end

    def set_access_token(token)
      @header = { "Authorization" => "Basic #{token}", "Content-Type" => "application/json"}
    end

  end
end
