module Kanoah
  module Services
    module TestRun

      def post_new_test_run(body)
        @response = self.class.post("/rest/kanoahtests/1.0/testrun", body: body.to_json, headers: @header)
        self
      end

      def get_run_details(test_run_key)
        @response = self.class.get("/rest/kanoahtests/1.0/testrun/#{test_run_key}", headers: @header)
        self
      end

      def post_new_result_to_run(scenario)
        @response = self.class.post("/rest/kanoahtests/1.0/testrun/#{@test_run_id}/testcase/#{scenario[:test_case]}/testresult",
                                    body: { 'status' => scenario[:status], 'environment' => @environment, 'comment' => scenario[:comment], 'executionTime' => scenario[:execution_time], 'scriptResults' => scenario[:script_results]}.to_json,
                                    headers: @header)
        self
      end

      def update_result_of_run(test_run_key, test_case_key, body)
        @response = self.class.put("/rest/kanoahtests/1.0/testrun/#{test_run_key}/testcase/#{test_case_key}/testresult", body: body.to_json, headers: @header)
        self
      end

      def get_test_runs(project_key)
        @response = self.class.get("/rest/kanoahtests/1.0/testrun/search?query=projectKey = '#{project_key}'", headers: @header)
        self
      end
    end
  end
end
